/* objoctcyl.h - structure values for octagonal cylinder*/

{       "Knife of Death", "knife", /* long and short names */
        "cube",         /* long name of dual */
        21, 40, 21,     /* number of vertices, edges, and faces */
        {               /* vertices (x,y,z) */
                        /* all points must be within radius 1 of the origin */

#define Oct(R,Z) DoOct(R, 2*R/5, Z)
#define DoOct(R1,R2,Z) \
                 {  R2,  R1,  Z }, \
                 {  R1,  R2,  Z }, \
                 {  R1, -R2,  Z }, \
                 {  R2, -R1,  Z }, \
                 { -R2, -R1,  Z }, \
                 { -R1, -R2,  Z }, \
                 { -R1,  R2,  Z }, \
                 { -R2,  R1,  Z }  

#define Diamond(R, Z) \
            {-R/6, 0,  Z}, \
            { 0,   R,  Z}, \
            { R/6, 0,  Z}, \
            { 0,  -R,  Z}

               Oct(  12,  60), 
               Oct(  8,    0),
               Diamond(30, -100),
               {0, 0, -180}
#undef Oct
#undef DoOct
#undef Diamond
        },
        {       /* faces (numfaces + indexes into vertices) */
                /*  faces must be specified clockwise from the outside */

            8,  0,  1,  2,  3,  4,  5,  6,  7,

#define Cyl(I1, I2) \
            4,  I1+0, I2+0, I2+1, I1+1, \
            4,  I1+1, I2+1, I2+2, I1+2, \
            4,  I1+2, I2+2, I2+3, I1+3, \
            4,  I1+3, I2+3, I2+4, I1+4, \
            4,  I1+4, I2+4, I2+5, I1+5, \
            4,  I1+5, I2+5, I2+6, I1+6, \
            4,  I1+6, I2+6, I2+7, I1+7, \
            4,  I1+7, I2+7, I2+0, I1+0, 
            
            Cyl( 0,  8)
#undef Cyl            

            4, 14, 16, 17, 15,
            3, 15, 17,  8,
            4,  8, 17, 18,  9,
            3,  9, 18, 10,
            4, 10, 18, 19, 11,
            3, 11, 19, 12,
            4, 12, 19, 16, 13,
            3, 13, 14, 16,
            
            3, 16, 20, 17,
            3, 17, 20, 18,
            3, 18, 20, 19,
            3, 19, 20, 16,
         }
},

